/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: term.h,v 1.1.1.1 2000/07/29 19:53:07 malekith Exp $ */

#ifndef _TERM_H
#define _TERM_H

#define COLOR(fg,bg) (fg|(bg<<4))
enum COLORS { 
	BLACK, BLUE, GREEN, CYAN, RED, MAGENTA, BROWN, LIGHTGRAY, 
	DARKGRAY, LIGHTBLUE, LIGHTGREEN, LIGHTCYAN, LIGHTRED,
	LIGHTMAGENTA, YELLOW, WHITE
};

extern int s_width, s_height;
extern int scroll_top, scroll_bottom;

enum {
	key_special = 0x10000,
	key_left, key_right, key_up, key_down, key_home,
	key_end, key_ins, key_del, key_pgdn, key_pgup,
	key_5, key_mouse,
	key_f0 = key_special + 0x100,
	key_meta = 0x100000
};

#define key_f(a) (key_f0 + (a))
#define key_ctrl(a) (a & 0x9f)

void init_curses();
void kill_curses();
void set_color(int vga);
int tprintf(const char *str, ...) __attribute__ ((format(printf, 1, 2)));
void tputchar(int ch);
void tputchar2(int ch, int color);
void stick_cursor();
void go(int x, int y);
void f_repaint();
void repaint();
int get_frame(int x, int y);
void scroll_up(int n);
void cls();

int _keyb();
#ifndef getch
inline int getch() { return _keyb(); }
#endif

#endif /* _V_TERM_H */
