/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: window.c,v 1.1.1.1 2000/07/29 19:53:07 malekith Exp $ */

#include "schiza.h"

struct line {
	struct line *next, *prev;
	char data[0];
};

struct window {
	struct window *next;
	int no;
	char *title;
	
	int offset;	/* offset at top line */
	struct line *first, *last, *top;
	int down;	/* whatever we're at the bottom of the scrollback */
	int pos_top, pos_bottom;
};

static int count_chars(char *p)
{
	int len = 0;
	
	while (*p && *p != ' ' && *p != '\t')
		if (*p == '\e')
			p += 2;
		else {
			len++;
			p++;
		}
	return len;
}

static char *print_line(char *p, int w, int dry)
{
	int color;

	if (w == 0)
		return 0;
		
	while (*p && w--) {
		if (*p == '\e') {
			color = (unsigned char)*++p;
			w++;
		} else if (*p == ' ' || *p == '\t') {
			if (count_chars(p + 1) > w - 1) {
				while (*p == ' ' || *p == '\t')
					p++;
				break;
			}
		} else if (dry) {
			/* nothing */
		} else if (*p < 32) {
			tputchar2(*p, COLOR(BLACK, WHITE));
		} else
			tputchar2(*p, color);
		p++;
	}
	
	if (*p == 0)
		p = 0;
	return p;
}

static struct line *compile_line(char **pp)
{
	int len;
	struct line *r;

	len = line_count_len(*pp);
	p = *pp;
	r = malloc(sizeof(struct line) + len + 1);
	r->next = r->prev = 0;
	
	*pp = line_do_compile(*pp, r->data);
	
	return r;
}

static int count_lines(char *p)
{
	int l;

	while (p && *p) {
		p = print_line(p, s_width - (l ? 8 : 0), 1);
		l++;
	}
	return l;
}

void win_add_text(struct window *w, char *line)
{
	struct line *x;
	
	while (line && *line) {
		x = compile_line(&line);
		if (w->last)
			w->last->next = x;
		x->prev = w->last;
		w->last = x;
		if (w->down) {
			!!!!!!!!
		}
	}
}

void win_paint(struct window *w)
{
	int y;
	char *p;
	struct line *l;
	int cont = 0;

	if ((l = top) == 0)
		return;

	if (strlen((p = l->data)) > offset)
		p += offset;
	
	for (y = pos_top; y <= pos_bottom; y++) {
		go(y, 0);
		if (cont) {
			tprintf("       ");
			p = print_line(p, s_width - 8, 0);
		} else
			p = print_line(p, s_width, 0);
		cont = 1;
		if (p)
			continue;
		l = l->next;
		if (l == 0)
			break;
		p = l->data;
		cont = 0;
	}
}

