/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: logic.cc,v 1.3 2000/08/27 18:32:51 malekith Exp $ */

#include "config.h"
extern "C" {
#include "lib.h"
};
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "logic.h"

//--------------------------------------------------------------------------
// StringList
char *StringList::add(const char *str)
{
	if (n >= an) {
		an += 50;
		ptrs = (char**)xrealloc(ptrs, an * sizeof (char*));
		if (!ptrs)
			abort();
	}
	return ptrs[n++] = xstrdup(str);
}

StringList::~StringList()
{
	for (int i=0; i<n; i++)
		xfree(ptrs[i]);
	xfree(ptrs);
	ptrs = 0;
	n = an = 0;
}

static int check_len(const char *p)
{
	int n = 0;
	
	while (*p == ' ' || *p == '\t')
		p++;
	for (; *p && *p != ' ' && *p != '\t'; p++)
		if (*p == '\e')
			n--;
		else
			n++;
	return n;
}

void IrcBuffer::split_line(const char *s)
{
	int n, tmp;
	const char *beg, *start = "";
	char *a;

	n = 0;
	beg = s;
	
	for (;;) {
		if (((*s == ' ' || *s == '\t') && n + check_len(s) > w)
		    || n > w || *s == 0) {
			tmp = strlen(start);
			a = (char *) xmalloc(tmp + (s - beg) + 1);
			strcpy(a, start);
			memcpy(a + tmp, beg, s - beg);
			a[tmp + (s - beg)] = 0;
			do_add(a);
			xfree(a);
			
			while (*s == ' ' || *s == '\t')
				s++;
			beg = s;	
			n = strlen(CONT_STRING);
			start = CONT_STRING;
			if (get_bool(B_NO_CONT) || n > w) {	/* oops */
				start = "";
				n = 0;
			}
		}
		if (*s == 0)
			break;
		if (*s == '\e')
			n--;
		else
			n++;
		s++;
	}
}

void IrcBuffer::do_add(const char *s)
{
	caption.add(s);
}

void IrcBuffer::add(const char *sc)
{
	char *s, *e, *f;
	
	f = s = xstrdup(sc);
	
	do {
		e = strchr(s, '\n');
		if (e)
			*e++ = 0;
		split_line(s);
		s = e;
	} while (s && *s);
	xfree(f);
}

void IrcBuffer::clr()
{
	caption.~StringList();
}
